package com.bytesw.juego;

import com.bytesw.baraja.cartas.Carta;

import java.util.ArrayList;

public class Jugador {
    private String nombre;
    private int saldoTotal;
    private int apuesta;    //La apuesta que hizo cuando inicio un juego
    private int jugadas;    //Numero de jugadas del jugador
    private ArrayList<HistoricoResultado> historicoResultados;
    private Mano mano;

    public Jugador(String nombre) {
        this.nombre = nombre;
        historicoResultados= new ArrayList<>();
    }

    public void agregarMano(Mano mano){
        this.mano= mano;
    }

    public void agregarHistorico(HistoricoResultado historicoResultado){
        historicoResultados.add(historicoResultado);
    }

    public void obtenerHistoricos(){
        for (HistoricoResultado historicoResultado : historicoResultados) {
            System.out.println(historicoResultado.toString());
        }
    }

    //Metodo que pone la carta que le dio el crupier en su mano
    // Y le aumenta sus jugadas en 1
    public void ponerEnLaManoLaCarta(Carta carta){
        jugadas++;
        mano.agregarCarta(carta);
    }

    //Verifica si el jugador supero el valor 21
    public boolean superoElValor21(){
        int suma= obtenerValorDeLaMano();
        boolean verificar=false;
        if (suma > 21) {
            verificar=true;
        }
        return verificar;
    }

    //Obtiene el valor de la mano la suma
    public int obtenerValorDeLaMano(){
        return mano.sumarCartasEnLaMano();
    }

    public void sumarGanancia(int gananciaXJuego){
        if (gananciaXJuego > 0) {
            System.out.println("Ganaste: " + (gananciaXJuego));
        } else {
            System.out.println("Perdise: " + (gananciaXJuego));
        }
        setSaldoTotal(getSaldoTotal() + (gananciaXJuego));
    }

    public String getNombre(){
        return nombre;
    }

    public int getJugadas(){
        return jugadas;
    }

    public void setJugadas(int jugadas){
        this.jugadas=jugadas;
    }

    public void setSaldoTotal(int saldoTotal) {
        this.saldoTotal = saldoTotal;
    }

    public int getSaldoTotal() {
        return saldoTotal;
    }

    public void setApuesta(int apuesta) {
        this.apuesta = apuesta;
    }

    public int getApuesta() {
        return apuesta;
    }
}
